/* Prototypes.
 * Stolen from os_unix_pro.h and gui_x11_pro.h
 */
void mch_write __ARGS((char_u *s, int len));
int mch_inchar __ARGS((char_u *buf, int maxlen, long wtime));
int mch_char_avail __ARGS((void));
long_u mch_avail_mem __ARGS((int special));
void mch_delay __ARGS((long msec, int ignoreinput));
void mch_suspend __ARGS((void));
void mch_windinit __ARGS((void));
int mch_check_win __ARGS((int argc, char **argv));
int mch_input_isatty __ARGS((void));
int mch_can_restore_title __ARGS((void));
int mch_can_restore_icon __ARGS((void));
void mch_settitle __ARGS((char_u *title, char_u *icon));
void mch_restore_title __ARGS((int which));
int mch_get_user_name __ARGS((char_u *s, int len));
void mch_get_host_name __ARGS((char_u *s, int len));
long mch_get_pid __ARGS((void));
int mch_dirname __ARGS((char_u *buf, int len));
int mch_FullName __ARGS((char_u *fname, char_u *buf, int len, int force));
int mch_isFullName __ARGS((char_u *fname));
long mch_getperm __ARGS((char_u *name));
int mch_setperm __ARGS((char_u *name, long perm));
void mch_hide __ARGS((char_u *name));
int mch_isdir __ARGS((char_u *name));
void mch_windexit __ARGS((int r));
void mch_settmode __ARGS((int tmode));
void mch_setmouse __ARGS((int on));
int mch_screenmode __ARGS((char_u *arg));
int mch_get_winsize __ARGS((void));
void mch_set_winsize __ARGS((void));
int mch_call_shell __ARGS((char_u *cmd, int options));
void mch_breakcheck __ARGS((void));
int mch_expandpath __ARGS((struct growarray *gap, char_u *path, int flags));
int mch_expand_wildcards __ARGS((int num_pat, char_u **pat, int *num_file, char_u ***file, int flags));
int mch_has_wildcard __ARGS((char_u *p));
int mch_remove __ARGS((char_u *file));

void gui_mch_prepare (int *argc, char **argv);
int gui_mch_init (void);
void gui_mch_new_colors (void);
int gui_mch_open (void);
void gui_mch_exit (int rc);
void gui_mch_set_winsize (int width, int height, int min_width, int min_height, int base_width, int base_height);
void gui_mch_get_screen_dimensions (int *screen_w, int *screen_h);
int gui_mch_init_font (char_u *font_name);
GuiFont gui_mch_get_font (char_u *name, int giveErrorIfMissing);
void gui_mch_set_font (GuiFont font);
int gui_mch_same_font (GuiFont f1, GuiFont f2);
void gui_mch_free_font (GuiFont font);
GuiColor gui_mch_get_color (char_u *name);
void gui_mch_set_fg_color (GuiColor color);
void gui_mch_set_bg_color (GuiColor color);
void gui_mch_draw_string (int row, int col, char_u *s, int len, int flags);
int gui_mch_haskey (char_u *name);
void gui_mch_beep (void);
void gui_mch_flash (void);
void gui_mch_invert_rectangle (int r, int c, int nr, int nc);
void gui_mch_iconify (void);
void gui_mch_draw_hollow_cursor (GuiColor color);
void gui_mch_draw_part_cursor (int w, int h, GuiColor color);
void gui_mch_update (void);
int gui_mch_wait_for_chars (long wtime);
void gui_mch_flush (void);
void gui_mch_clear_block (int row1, int col1, int row2, int col2);
void gui_mch_clear_all (void);
void gui_mch_delete_lines (int row, int num_lines);
void gui_mch_insert_lines (int row, int num_lines);
void clip_mch_request_selection (void);
void clip_mch_lose_selection (void);
int clip_mch_own_selection (void);
void clip_mch_set_selection (void);
void gui_mch_menu_grey (GuiMenu *menu, int grey);
void gui_mch_menu_hidden (GuiMenu *menu, int hidden);
void gui_mch_draw_menubar (void);
void gui_mch_enable_scrollbar (GuiScrollbar *sb, int flag);
void gui_mch_set_blinking (long waittime, long on, long off);
void gui_mch_stop_blink (void);
void gui_mch_start_blink (void);
int gui_mch_get_lightness (GuiColor pixel);
char_u *gui_mch_get_rgb (GuiColor pixel);

void process_event(int event, int *block);
